/* Automatically generated from Squeak on #(13 October 2001 4:36:27 pm) */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

/* Default EXPORT macro that does nothing (see comment in sq.h): */
#define EXPORT(returnType) returnType

/* Do not include the entire sq.h file but just those parts needed. */
/*  The virtual machine proxy definition */
#include "sqVirtualMachine.h"
/* Configuration options */
#include "sqConfig.h"
/* Platform specific definitions */
#include "sqPlatformSpecific.h"

#define true 1
#define false 0
#define null 0  /* using 'null' because nil is predefined in Think C */
#include <gpgme.h>

/* memory access macros */
#define byteAt(i) (*((unsigned char *) (i)))
#define byteAtput(i, val) (*((unsigned char *) (i)) = val)
#define longAt(i) (*((int *) (i)))
#define longAtput(i, val) (*((int *) (i)) = val)

/*** Variables ...***/
GpgmeCtx * contexts;
struct VirtualMachine* interpreterProxy;
const char *moduleName = "GPGPlugin 13 October 2001 (e)";

/*** Function Prototypes ***/
static int checkSession(int anOop);
#pragma export on
EXPORT(int) doStuff(void);
#pragma export off
static int findNewContextHandle(void);
static int flag(int ignored);
static int getArmor(int context);
#pragma export on
EXPORT(const char*) getModuleName(void);
#pragma export off
static int getSession(void);
static int getTextmode(int context);
static int initialiseModule(void);
static int maxContextHandles(void);
static int newContext(int context);
static int newData(int data);
static int newDatafromFile(int data, int filename);
static int newDatafromFilefromto(int data, int filename, int start, int end);
static int newDatafromMemory(int data, int memoryData);
#pragma export on
EXPORT(int) primitiveNewContext(void);
#pragma export off
static int readDataintofromto(int data, int buffer, int start, int end);
static int releaseData(int data);
static int setArmorto(int context, int aBoolean);
#pragma export on
EXPORT(int) setInterpreter(struct VirtualMachine* anInterpreter);
#pragma export off
static int setPasswordForto(int context, int aString);
static int setTextmodeto(int context, int modeInteger);
static int writeDatafrom(int data, int buffer);


/*	check that the specified object has a current session */

static int checkSession(int anOop) {
	int session;

	/* begin flag: */
	/* begin flag: */
	session = interpreterProxy->fetchIntegerofObject(0, anOop);
	if (interpreterProxy->failed()) {
		return 0;
	}
	if (!(session == (getSession()))) {
		return 0;
	}
	return 1;
}

EXPORT(int) doStuff(void) {
	printf("dostuff\n");
}


/*	find an unused context handle */

static int findNewContextHandle(void) {
	int handle;

	for (handle = 0; handle <= (100 - 1); handle += 1) {
		if (contexts[handle] == NULL) {
			return handle;
		}
	}
	printf("could not allocate handle\n");
	return -1;
}


/*	so that I can flag things... */

static int flag(int ignored) {
}

static int getArmor(int context) {
}


/*	Note: This is hardcoded so it can be run from Squeak.
	The module name is used for validating a module *after*
	it is loaded to check if it does really contain the module
	we're thinking it contains. This is important! */

EXPORT(const char*) getModuleName(void) {
	return moduleName;
}


/*	return the current session */

static int getSession(void) {
	extern int thisSession;

	/* begin flag: */
	return thisSession;
}

static int getTextmode(int context) {
}

static int initialiseModule(void) {
	contexts = malloc(maxContextHandles() * sizeof(contexts[0]));
}


/*	maximum number of handles that can be allocated */

static int maxContextHandles(void) {
	return 100;
}

static int newContext(int context) {
}

static int newData(int data) {
}

static int newDatafromFile(int data, int filename) {
}

static int newDatafromFilefromto(int data, int filename, int start, int end) {
}


/*	either a string or a ByteArray */

static int newDatafromMemory(int data, int memoryData) {
}

EXPORT(int) primitiveNewContext(void) {
	int handle;
	int retval;
	int context;
	int _return_value;

	context = interpreterProxy->stackValue(0);
	if (interpreterProxy->failed()) {
		return null;
	}
	if ((slotSizeOf(context)) != 2) {
		interpreterProxy->success(0);
		_return_value = interpreterProxy->nilObject();
		if (interpreterProxy->failed()) {
			return null;
		}
		interpreterProxy->popthenPush(2, _return_value);
		return null;
	}
	handle = findNewContextHandle();
	if (handle < 0) {
		interpreterProxy->success(0);
		_return_value = interpreterProxy->nilObject();
		if (interpreterProxy->failed()) {
			return null;
		}
		interpreterProxy->popthenPush(2, _return_value);
		return null;
	}
	interpreterProxy->storeIntegerofObjectwithValue(0, context, getSession());
	retval = gpgme_new(&contexts[handle]);
	if (retval == 0) {
		interpreterProxy->storeIntegerofObjectwithValue(1, context, handle);
	} else {
		contexts[handle] = NULL;
		interpreterProxy->storeIntegerofObjectwithValue(1, context, -1);
	}
	_return_value = ((retval << 1) | 1);
	if (interpreterProxy->failed()) {
		return null;
	}
	interpreterProxy->popthenPush(2, _return_value);
	return null;
}

static int readDataintofromto(int data, int buffer, int start, int end) {
}

static int releaseData(int data) {
}

static int setArmorto(int context, int aBoolean) {
}


/*	Note: This is coded so that is can be run from Squeak. */

EXPORT(int) setInterpreter(struct VirtualMachine* anInterpreter) {
	int ok;

	interpreterProxy = anInterpreter;
	ok = interpreterProxy->majorVersion() == VM_PROXY_MAJOR;
	if (ok == 0) {
		return 0;
	}
	ok = interpreterProxy->minorVersion() >= VM_PROXY_MINOR;
	return ok;
}

static int setPasswordForto(int context, int aString) {
}


/*	put in a reference to the list of allowed constants */

static int setTextmodeto(int context, int modeInteger) {
}

static int writeDatafrom(int data, int buffer) {
}
